#include "gfcommon.h"
#include <qfile.h>

#ifndef GFCOMMENTS
#define GFCOMMENTS

/*

	GfComments class 
	


*/

#define LOCATION_ROWCOL 0
#define LOCATION_DATA 1


class GfComments
{

public:
	GfComments(); 
	GfComments(const GfComments &); // copy constructor
	GfComments(const GfComments *); // copy constructor
	
	virtual ~GfComments();
	
	int addComment(const char *, float , float ,int  );
	int removeComment(int );
	int setComment(int, const char *, float , float , int);
	int setComment(int, const char *, float , float);
	
	int numComments() const ;
	void comment(int , char *) const ;
	int locationType(int ) const ;
	float locationX(int ) const ;
	float locationY(int ) const ;
	
	int setFont(int i,int f);
	int setFontSize(int,float);
	int setColor(int i,int c);

	int commentLen(int) const ;
	int font(int) const ;
	float fontSize(int) const ;
	int color(int) const ;
	
	void removeAll();
	
	void print(OSTREAM *);
	void format(OSTREAM *);
	int readFormat(QFile *in,char *line);
	
	void operator=(const GfComments &); // assignment operator
	

private:

	char **comments;
	
	int *loctype;
	
	float *xloc,*yloc,*fontsize;
	
	int *fonts,*colors;
	
	int numcomments;

	void init();
	
	void storage(int);
	
};

OSTREAM &operator<<(OSTREAM &os, GfComments *m);
OSTREAM &operator<<(OSTREAM &os, GfComments &m);


#endif // GfComments
