#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

/*
	gfcommon.h
	
*/

#ifndef GFCOMMONH
#define GFCOMMONH

#define GFMAGIC "C ***GfQt***: "
const float GFEXTENDVER=1.0;

// general defines

#define GF_YES 1
#define GF_NO 0

// return values
#define GF_OK 1
#define GF_BAD 0

// maximum data line length in a input file
#define MAX_LINE_LEN 200


//  for plotdefs

#define PSJOIN_MITER 0
#define PSJOIN_ROUND 1
#define PSJOIN_BEVEL 2

#define NUM_PSJOIN 3

#ifdef GFMAIN
char *psjoin[] ={"miter","round","bevel"};
#else
extern char *psjoin[];
#endif


// for curves

// line types
#define LT_SOLID 0
#define LT_DASHED 1

#define NUM_INVEC_NAMES 13

#ifdef GFMAIN 
char *invec_names[]={"new line","line","square","circle","triangle","cone",
	"solid square","solid circle","solid triangle","solid cone",
	"cross","arrow line","solid arrow line"};
#else
extern char *invec_names[];
#endif


// for draw

// colors
#define BLACK 0

#define NUM_PSCOLORS 8

#ifdef GFMAIN
char *pscolors[] ={"black","blue","green","red","cyan","magenta",
		"saddle brown","white"};
#else
extern char *pscolors[];
#endif

#define NUM_PSLINETYPES 6

#ifdef GFMAIN
char *psdash[]={"solid","dots","dashed","long short",
		"long short short","long dashed(ps only)"};
#else
extern char *psdash[];
#endif


#define NUM_PSLINEWIDTHS 6

#define LW_DEFAULT 2
#define LW_BOX 4

#ifdef GFMAIN
char *pswidths[]={"3","6","12","18","28","36"};
#else
extern char *pswidths[];
#endif

#define NUM_PSFONTS 9
#define PS_DEF_FONT 1
#define PS_DEF_FONTSIZE 1.0
#define PS_SYMBOLFONT 6

#ifdef GFMAIN

char *psfont[] = {"/Helvetica-Bold",
      "/Helvetica",
      "/Helvetica-BoldOblique",
      "/Times-Roman",
      "/Times-Bold",
      "/Times-Italic",
      "/Symbol",
      "/Palatino-Roman",
      "/Palatino-Bold"};
      
#else
extern char *psfont[];
#endif

// for extended file format

#define CURVEMAGIC "C curve: "
#define SCALEMAGIC "C scale:"
#define COMMENTSMAGIC "C comment: "
#define PROFILEMAGIC "C profile:"
#define PLOTDEFSMAGIC "C plotdefs:"

#ifndef OSTREAM

#ifdef QT

#include <qtextstream.h>
#define OSTREAM QTextStream
#define ISTREAM QTextStream

#ifdef MAIN
 	QTextStream cout( stdout, IO_WriteOnly );
    	QTextStream cin ( stdin,  IO_ReadOnly );
   	QTextStream cerr( stderr, IO_WriteOnly );
#else
	extern QTextStream cout;
	extern QTextStream cin;
	extern QTextStream cerr;
#endif

#else

#include <iostream.h>
#define OSTREAM ostream
#define ISTREAM istream
#endif


#endif

#endif
