/**********************************************************************

	--- Qt Architect generated file ---

	File: GfPlotDefsWin.cpp
	Last generated: Tue Jul 6 21:01:21 1999

 *********************************************************************/

#include "GfPlotDefsWin.h"
#include "../gfdraw.h"
#include <qmessagebox.h>

#define Inherited GfPlotDefsWinData

GfPlotDefsWin::GfPlotDefsWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "Page Setup" );
	
	// private does not get called
}

GfPlotDefsWin::GfPlotDefsWin
(
	GfFile *gff
)
	:
	Inherited( NULL, NULL )
{
	setCaption( "Page Setup" );
	
	gffile = gff;
	
	plotdefs = gffile->plotDefs();
	
	init();
}

void GfPlotDefsWin::init()
{
int i;
char text[30];

	dvalid = new QDoubleValidator(10.,0.1,6,this);

	for(i=0;i<NUM_PSCOLORS;i++)
	{
		color_combobox->insertItem(pscolors[i]);
	}
	
	for(i=0;i<NUM_PSFONTS;i++)
	{
		font_combobox->insertItem((psfont[i]+1));
	}		

	for(i=0;i<NUM_PSJOIN;i++)
	{
		psjoin_combobox->insertItem(psjoin[i]);
	}		

	fontsize_lineedit->setValidator(dvalid);
	xsize_lineedit->setValidator(dvalid);
	ysize_lineedit->setValidator(dvalid);
	
	if(plotdefs.encapsulated() == GF_YES)
	{
		encap_checkbox->setChecked(TRUE);
	}
	else
	{
		encap_checkbox->setChecked(FALSE);
	}
	
	psjoin_combobox->setCurrentItem(plotdefs.psJoin());
	
	if(plotdefs.rotatePlot() == GF_YES)
	{
		portrait_radiobutton->setChecked(TRUE);
	}
	else
	{
		landscape_radiobutton->setChecked(TRUE);
	}
	
	sprintf(text,"%g",plotdefs.xPlotSize());
	xsize_lineedit->setText(text);
	
	sprintf(text,"%g",plotdefs.yPlotSize());
	ysize_lineedit->setText(text);
	
	if(plotdefs.axesVisible() == GF_YES)
	{
		plotaxes_checkbox->setChecked(TRUE);
	}
	else
	{
		plotaxes_checkbox->setChecked(FALSE);
	}
	
	if(plotdefs.commentsVisible() == GF_YES)
	{
		plotcomments_checkbox->setChecked(TRUE);
	}
	else
	{
		plotcomments_checkbox->setChecked(FALSE);
	}
	
	if(plotdefs.curvesVisible() == GF_YES)
	{
		plotcurves_checkbox->setChecked(TRUE);
	}
	else
	{
		plotcurves_checkbox->setChecked(FALSE);
	}
	
	font_combobox->setCurrentItem(plotdefs.font());
	color_combobox->setCurrentItem(plotdefs.color());

	sprintf(text,"%g",plotdefs.fontSize());
	fontsize_lineedit->setText(text);
	
	sprintf(text,"%g",plotdefs.symbolSize());
	symbolsize_lineedit->setText(text);
	
	sprintf(text,"%g",plotdefs.arrowSize());
	arrowsize_lineedit->setText(text);
	
}

GfPlotDefsWin::~GfPlotDefsWin()
{
	delete dvalid;
}


void GfPlotDefsWin::acceptButton()
{

	if(encap_checkbox->isChecked() == TRUE)
	{
		plotdefs.setEncapsulated(GF_YES);
	}
	else
	{
		plotdefs.setEncapsulated(GF_NO);
	}
	
	
	plotdefs.setPSJoin(psjoin_combobox->currentItem());
	
	if(portrait_radiobutton->isChecked() == TRUE)
	{
		plotdefs.setRotatePlot(GF_YES);
	}
	else
	{
		plotdefs.setRotatePlot(GF_NO);
	}
	
	plotdefs.setPlotSize(atof(xsize_lineedit->text()),atof(ysize_lineedit->text()));
	
	if(plotaxes_checkbox->isChecked() == TRUE)
	{
		plotdefs.setAxesVisibility(GF_YES);
	}
	else
	{
		plotdefs.setAxesVisibility(GF_NO);
	}
	
	if(plotcomments_checkbox->isChecked() == TRUE)
	{
		plotdefs.setCommentsVisibility(GF_YES);
	}
	else
	{
		plotdefs.setCommentsVisibility(GF_NO);
	}
	
	if(plotcurves_checkbox->isChecked() == TRUE)
	{
		plotdefs.setCurvesVisibility(GF_YES);
	}
	else
	{
		plotdefs.setCurvesVisibility(GF_NO);
	}
		
	plotdefs.setFont(font_combobox->currentItem());
	plotdefs.setColor(color_combobox->currentItem());

	plotdefs.setFontSize(atof(fontsize_lineedit->text()));
	plotdefs.setSymbolSize(atof(symbolsize_lineedit->text()));
	plotdefs.setArrowSize(atof(arrowsize_lineedit->text()));
		
	
	GfDraw gfd;
	
	if(gfd.initPS(NULL,&plotdefs,NULL) == GF_BAD)
	{
		
		QMessageBox mb("Error","Plot Size Bad",QMessageBox::NoIcon,
			QMessageBox::Ok | QMessageBox::Default,0,0,this);
		
		mb.exec();
		return;
	}
		
	gffile->setPlotDefs(plotdefs);

	emit plotDefsChanged();
	
	done(0);
}

void GfPlotDefsWin::cancelButton()
{
	done(0);

}

