/**********************************************************************

	--- Qt Architect generated file ---

	File: GfProfileWin.cpp
	Last generated: Tue Jun 22 18:18:45 1999

 *********************************************************************/

#include "GfProfileWin.h"

#define Inherited GfProfileWinData

GfProfileWin::GfProfileWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "File Format" );
	
	init();
}

GfProfileWin::GfProfileWin
(
	GfFile *gff
)
	:
	Inherited( NULL, NULL )
{
	setCaption( "File Format" );
	
	
	gffile = gff;
	
	gfprofile = gffile->profile();
	
	init();
	
}

void GfProfileWin::init()
{
int c;

	if(gfprofile.lineFormat() == FMT_FIXED)
	{
		use_fixed_radio->setChecked(TRUE);
		use_delim_radio->setChecked(FALSE);
	}
	else
	{
		use_fixed_radio->setChecked(FALSE);
		use_delim_radio->setChecked(TRUE);
	}
	
	data_spinbox->setValue(gfprofile.dataLength());
	invec_spinbox->setValue(gfprofile.invecLength());
	
	switch(gfprofile.delimChar())
	{
		default:
		case '\t': // tab
			c = 0;
		break;
			
		case ' ': // space
			c = 1;
		break;
			
		case ',': // comma
			c = 2;
		break;
			
	}
		
	delim_listbox->setCurrentItem(c);
		
	if(gfprofile.invecLength() > 0 )
	{
		use_invec_box->setChecked(TRUE);
	}
	else
	{
		use_invec_box->setChecked(FALSE);
	}
	
	setVisibles();
}

GfProfileWin::~GfProfileWin()
{
}


void GfProfileWin::setVisibles()
{

	if(use_fixed_radio->isChecked())
	{
		invec_spinbox->setEnabled(TRUE);
    		data_spinbox->setEnabled(TRUE);
    		use_invec_box->setEnabled(FALSE);
    		delim_listbox->setEnabled(FALSE);
		f1_label->setEnabled(TRUE);
		f2_label->setEnabled(TRUE);
		f3_label->setEnabled(TRUE);
		d1_label->setEnabled(FALSE);
		d2_label->setEnabled(FALSE);
	}
	else
	{
		invec_spinbox->setEnabled(FALSE);
    		data_spinbox->setEnabled(FALSE);
    		use_invec_box->setEnabled(TRUE);
    		delim_listbox->setEnabled(TRUE);
		f1_label->setEnabled(FALSE);
		f2_label->setEnabled(FALSE);
		f3_label->setEnabled(FALSE);
		d1_label->setEnabled(TRUE);
		d2_label->setEnabled(TRUE);
	}

}

void GfProfileWin::cancelButton()
{
	done(0);
}

void GfProfileWin::acceptButton()
{
char c;

	if(use_fixed_radio->isChecked())
	{
		gfprofile.setLineFormat(FMT_FIXED);
		gfprofile.setDataLength(data_spinbox->value());
		gfprofile.setInvecLength(invec_spinbox->value());
	}
	else
	{
		gfprofile.setLineFormat(FMT_DELIM);
		
		switch(delim_listbox->currentItem())
		{
			default:
			case 0: // tab
				c = '\t';
			break;
			
			case 1: // space
				c = ' ';
			break;
			
			case 2: // comma
				c = ',';
			break;
			
		}
		gfprofile.setDelimChar(c);
		
		if( use_invec_box->isChecked())
		{
			gfprofile.setInvecLength(3);
		}
		else
		{
			gfprofile.setInvecLength(0);
		}
			
	}
		
	gffile->setProfile(gfprofile);
	
	done(0);

}
