#include <qapp.h>

#define MAIN
#include "gfcommon.h"
#include "gffile.h"
#include "window/GfWindow.h"
#include "gfnumcolswin/GfNumcolsWin.h"
#include <qfile.h>


void new_file(char *filename=NULL) 
{
GfWindow *gfwin;
int ncols,xcol,ycol;

	if(filename != NULL)
	{
		if(strcmp(filename,"test.int") == 0)
		{
			GfFile gff;
			gff.test_mc();
			gfwin = new GfWindow();
			gfwin->setGfFile(gff);
			gfwin->show();
			return;
		}
				
		QFile qf(filename);
		if(qf.exists() == TRUE)
		{
			if(qf.open(IO_ReadOnly) != TRUE)
			{
				cout<<"open failed\n";
				exit(-1);
			}			
		}
		else
		{
			QString qs(filename);
			qs.append(".gf");
			
			qf.setName(qs);
			
			if(qf.exists() == TRUE)
			{
				if(qf.open(IO_ReadOnly) != TRUE)
				{
					cout<<"open failed\n";
					exit(-1);
				}			
			}
			else
			{
				cout <<"File not found\n";
				exit(-1);
			}
		}
		
		gfwin = new GfWindow();
			
		ncols = gfwin->checkNumCols(&qf);
		
		if(ncols > 2)
		{
			GfNumcolsWin gfnumcol(ncols,&xcol,&ycol);
				
			if(gfnumcol.exec() == GF_YES)
			{
				if(gfwin->read(&qf,xcol,ycol) == GF_BAD)
				{
					cout<<"read failed \n";
					exit(-1);
				}
			}
			else
			{
				exit(0);  // cancel clicked
			}
			
		}
		else
		{
			if(gfwin->read(&qf,1,2) == GF_BAD)
			{
				cout << "read failed \n";
				exit(-1);
			}
		}	
				
		gfwin->updateFileChange();
		gfwin->show();

	}
	else
	{
		gfwin = new GfWindow();
		gfwin->show(); // start with blank window to allow file format setting.
	}

}


main(int argc, char **argv)
{
QApplication a( argc, argv );

#ifndef UNIX
	a.setStyle(WindowsStyle);
#else
	a.setStyle(MotifStyle);
#endif

	gfInitMainWin(1);

	if(a.argc() > 1)
	{
		new_file(a.argv()[1]);		
	}
	else
	{
		new_file(NULL);
	}
		
	a.exec();

	exit(0);

}
